#ifndef OROCOS_CONTROLLER_COMPONENT_HPP
#define OROCOS_CONTROLLER_COMPONENT_HPP

#include <rtt/RTT.hpp>
#include <iostream>

using namespace RTT;
using namespace std;

class Controller: public RTT::TaskContext {

protected:
	InputPort<double> sensorValues;
	OutputPort<double> steeringSignals;
	Property<double> gain;

	// Generates a sine, used in the controller-program.ops script
	double tmp;

public:
	Controller(string const& name);

private:
	bool configureHook();
	bool startHook();
	void updateHook();
	void stopHook();
	void cleanupHook();
	double nextPosition();

};

#endif
